Accessibility in Vue Calendar component

18 Nov 20188 minutes to read

The Calendar component followed the accessibility guidelines and standards, including ADA, Section 508, WCAG 2.2 standards, and WCAG roles that are commonly used to evaluate accessibility.

The accessibility compliance for the Calendar component is outlined below.

Accessibility Criteria Compatibility
WCAG 2.2 Support Intermediate
Section 508 Support Intermediate
Screen Reader Support Yes
Right-To-Left Support Yes
Color Contrast Yes
Mobile Device Support Yes
Keyboard Navigation Support Yes
Accessibility Checker Validation Yes
Axe-core Accessibility Validation Yes
Yes - All features of the component meet the requirement.
Intermediate - Some features of the component do not meet the requirement.
No - The component does not meet the requirement.

WAI-ARIA attributes

The web accessibility makes web content and web applications more accessible for disabled people. It especially helps in dynamic content change and development of advanced user interface controls with AJAX, HTML, JavaScript, and related technologies.

Calendar provides built-in compliance with WAI-ARIA specifications. WAI-ARIA support is achieved through attributes like aria-label, aria-selected, aria-disabled, and aria-activedescendant applied for navigation buttons, and disable and active day cells.

It helps disabled persons by providing information about the widget for assistive technology in the screen readers. Calendar component contains grid role and grid cell for each day cell.

  • Aria-label: This attribute provides text labels for an object for the previous and next month’s elements. It helps the screen reader object to read.

  • Aria-selected: Indicates the currently selected date of the Calendar component.

  • Aria-disabled: Indicates the disabled state of the Calendar component.

  • Aria-activedescendent: Helps in managing the current active child of the Calendar component.

  • Role: Gives information to assistive technologies about how to handle each element in a widget.

  • Grid-cell: Defines the individual cell that can be focused and selected.

Keyboard interaction

You can use the following keys to interact with the Calendar. This component implements keyboard navigation support by following the WAI-ARIA practices.

It supports the following list of shortcut keys:

Press To do this
Upper Arrow Focuses the same day of the previous week.
Down Arrow Focuses the same day of the next week.
Left Arrow Focuses the day before.
Right Arrow Focuses the next day.
Home Focuses the first day of the month.
End Focuses the last day of the month.
Page Up Focuses the same date of the previous month.
Page Down Focuses the same date of the next month.
Enter Selects the currently focused date.
Shift + Page Up Focuses the same date for the previous year.
Shift + Page Down Focuses the same date for the next year.
Control + Upper Arrow Moves to the inner level of view like month to year and year to decade.
Control + Down Arrow Moves out from the depth level view like decade to year and year to month.
Control + Home Focuses the first date of the current year.
Control + End Focuses the last date of the current year.

To focus the Calendar component, use alt+t keys.

<template>
  <div id="app">
    <div class='wrap'>
      <ejs-calendar id='calendar' ref="CalendarInstance"></ejs-calendar>
    </div>
  </div>
</template>
<script setup>

import { CalendarComponent as EjsCalendar } from "@syncfusion/ej2-vue-calendars";
import { onMounted, ref } from "vue";

const CalendarInstance = ref(null);

onMounted(() => {
  let calendarObj = CalendarInstance.value;
  document.onkeyup = function (e) {
    if (e.altKey && e.keyCode === 84) {
      // press alt+t to focus the control.
      calendarObj.$el.querySelectorAll('.e-content table')[0].focus();
    }
  }
});
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrap {
  margin: 35px auto;
  width: 240px;
}
</style>
<template>
  <div id="app">
    <div class='wrap'>
      <ejs-calendar id='calendar' ref="CalendarInstance"></ejs-calendar>
    </div>
  </div>
</template>
<script>

import { CalendarComponent } from "@syncfusion/ej2-vue-calendars";


export default {
  name: "App",
  components: {
    "ejs-calendar": CalendarComponent
  },

  mounted() {
    let calendarObj = this.$refs.CalendarInstance;
    document.onkeyup = function (e) {
      if (e.altKey && e.keyCode === 84) {
        // press alt+t to focus the control.
        calendarObj.$el.querySelectorAll('.e-content table')[0].focus();
      }
    }
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrap {
  margin: 35px auto;
  width: 240px;
}
</style>

Ensuring accessibility

The Calendar component’s accessibility levels are ensured through an accessibility-checker and axe-core software tools during automated testing.

The accessibility compliance of the Calendar component is shown in the following sample. Open the sample in a new window to evaluate the accessibility of the Calendar component with accessibility tools.

See also

Accessibility in Angular Calendar component

18 Nov 20187 minutes to read

The Calendar component followed the accessibility guidelines and standards, including ADA, Section 508, WCAG 2.2 standards, and WCAG roles that are commonly used to evaluate accessibility.

The accessibility compliance for the Calendar component is outlined below.

Accessibility Criteria Compatibility
WCAG 2.2 Support Intermediate
Section 508 Support Intermediate
Screen Reader Support Yes
Right-To-Left Support Yes
Color Contrast Yes
Mobile Device Support Yes
Keyboard Navigation Support Yes
Accessibility Checker Validation Yes
Axe-core Accessibility Validation Yes
Yes - All features of the component meet the requirement.
Intermediate - Some features of the component do not meet the requirement.
No - The component does not meet the requirement.

WAI-ARIA attributes

The Web accessibility defines a way to make web content and web applications more accessible to disabled people. It especially helps the dynamic content change and advanced user interface controls developed with Ajax, HTML, JavaScript, and related technologies.

Calendar provides built-in compliance with the WAI-ARIA specifications. WAI-ARIA supports is achieved through the attributes like aria-label,aria-selected, aria-disabled, aria-activedescendant applied for navigation buttons, disable and active day cells.

It helps to provide the information about the widget for assistive technology to the disabled person in the screen reader. Calendar component contains grid as role and grid cell for each day cell

  • Aria-label : attribute provides the text label for an object for the previous and next month element. It helps the screen reader object to read for the assistive purpose.

  • Aria-selected : attribute indicates the currently selected date of the Calendar component.

  • Aria-disabled : attribute indicates the disabled state of this Calendar component.

  • Aria-activedescendent : attribute helps in managing the current active child of the Calendar component.

  • Role : attributes gives assistive technologies information about how to handle each element in a widget.

  • Grid-cell : attributes define the individual cell that can be focusable and selectable.

Keyboard Interaction

You can use the following keys to interact with the Calendar.
The component implements the keyboard navigation support by following the WAI-ARIA practices

It supports the below list of shortcut keys.

Press To do this
Upper Arrow Focus the previous week date.
Down Arrow Focus the next week date.
Left Arrow Focus the previous date.
Right Arrow Focus the next date.
Home Focus the first date in the month.
End Focus the last date in the month.
Page Up Focus the same date in the previous month.
Page Down Focus the same date in the next month.
Enter Select the currently focused date.
Shift + Page Up Focus the same date in the previous year.
Shift + Page Down Focus the same date in the next year.
Control + Upper Arrow Moves into the inner level of view like month-year, year-decade
Control + Down Arrow Moves out from the depth level view like decade-year, year-month
Control + Home Focus the starting date in the current year.
Control + End Focus the ending date in the current year.

To focus the Calendar component use the alt+t keys.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { CalendarModule } from '@syncfusion/ej2-angular-calendars'



import { Component,HostListener,ViewChild } from '@angular/core';

@Component({
imports: [
        
        CalendarModule //declaration of ej2-angular-calendars module into NgModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
        <ejs-calendar #ejCalendar [value]='dateValue'></ejs-calendar>
        `
})

export class AppComponent {
   @ViewChild('ejCalendar') ejCalendar: any;
    public dateValue: Date = new Date();
    @HostListener('document:keyup', ['$event'])
  handleKeyboardEvent(event: KeyboardEvent) {
    if (event.altKey && event.keyCode === 84) {
        // press alt+t to focus the control.
        this.ejCalendar.element.querySelectorAll('.e-content table')[0].focus();
    }
  }
    constructor() {
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Ensuring accessibility

The Calendar component’s accessibility levels are ensured through an accessibility-checker and axe-core software tools during automated testing.

The accessibility compliance of the Calendar component is shown in the following sample. Open the sample in a new window to evaluate the accessibility of the Calendar component with accessibility tools.

See also

Accessibility in React Calendar component

18 Nov 201812 minutes to read

The Calendar component follows accessibility guidelines and standards, including ADA, Section 508, WCAG 2.2, and related WAI-ARIA roles used to evaluate accessibility.

The accessibility compliance for the Calendar component is outlined below.

Accessibility Criteria Compatibility
WCAG 2.2 Support Intermediate
Section 508 Support Intermediate
Screen Reader Support Yes
Right-To-Left Support Yes
Color Contrast Yes
Mobile Device Support Yes
Keyboard Navigation Support Yes
Accessibility Checker Validation Yes
Axe-core Accessibility Validation Yes
Yes - All features of the component meet the requirement.
Intermediate - Some features of the component do not meet the requirement.
No - The component does not meet the requirement.

WAI-ARIA attributes

Web accessibility defines how to make web content and applications more accessible to people with disabilities. It especially addresses dynamic content changes and advanced UI controls developed with Ajax, HTML, JavaScript, and related technologies.

The Calendar provides built-in compliance with the WAI-ARIA specifications. WAI-ARIA support is provided through attributes such as aria-label, aria-selected, aria-disabled, and aria-activedescendant applied to navigation buttons and day cells.

This provides assistive technologies with information about the widget for screen reader users. The Calendar component uses the grid role with each day represented as a gridcell.

  • Aria-label : attribute provides the text label for an object for the previous and next month element. It helps the screen reader object to read for the assistive purpose.

  • Aria-selected : attribute indicates the currently selected date of the Calendar component.

  • Aria-disabled : attribute indicates the disabled state of this Calendar component.

  • Aria-activedescendant : attribute helps in managing the current active child of the Calendar component.

  • Role : attributes gives assistive technologies information about how to handle each element in a widget.

  • Grid-cell : attributes define the individual cell that can be focusable and selectable.

Keyboard Interaction

You can use the following keys to interact with the Calendar. The component implements the keyboard navigation support by following the WAI-ARIA practices

It supports the below list of shortcut keys.

Press To do this
Upper Arrow Focus the previous week date.
Down Arrow Focus the next week date.
Left Arrow Focus the previous date.
Right Arrow Focus the next date.
Home Focus the first date in the month.
End Focus the last date in the month.
Page Up Focus the same date in the previous month.
Page Down Focus the same date in the next month.
Enter Select the currently focused date.
Shift + Page Up Focus the same date in the previous year.
Shift + Page Down Focus the same date in the next year.
Control + Upper Arrow Moves into the inner level of view like month-year, year-decade
Control + Down Arrow Moves out from the depth level view like decade-year, year-month
Control + Home Focus the starting date in the current year.
Control + End Focus the ending date in the current year.

To focus the Calendar component use the alt+t keys.

[Class-component]

import { CalendarComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
export default class App extends React.Component {
    calendarInstance;
    componentDidMount() {
        const proxy = this;
        document.onkeyup = (e) => {
            if (e.altKey && e.keyCode === 84 /* t */) {
                // press altt to focus the control.
                proxy.calendarInstance.element.querySelector('table').focus();
            }
        };
    }
    render() {
        return (
        // specifies the tag for render the Calendar component
        <CalendarComponent id="calendar" ref={(scope) => { this.calendarInstance = scope; }}/>);
    }
}
ReactDOM.render(<App />, document.getElementById('element'));
import { Calendar, CalendarComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

export default class App extends React.Component<{}, {}> {

    private calendarInstance: Calendar;

    public componentDidMount() {
        const proxy = this;
        document.onkeyup = (e: KeyboardEvent) => {
            if (e.altKey && e.keyCode === 84 /* t */) {
                // press altt to focus the control.
                (proxy.calendarInstance.element.querySelector('table') as HTMLElement).focus();
            }
        };
    }

    public render() {
        return (
            // specifies the tag for render the Calendar component
            <CalendarComponent id="calendar" ref={(scope) => { (this.calendarInstance as Calendar | null) = scope; }}  />
        );
    }

 }

ReactDOM.render(<App />, document.getElementById('element'));

[Functional-component]

import { CalendarComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
function App() {
    let calendarInstance;
    React.useEffect(() => {
        const proxy = this;
        document.onkeyup = (e) => {
            if (e.altKey && e.keyCode === 84 /* t */) {
                // press altt to focus the control.
                proxy.calendarInstance.element.querySelector('table').focus();
            }
        };
    }, []);
    return (
    // specifies the tag for render the Calendar component
    <CalendarComponent id="calendar" ref={(scope) => { calendarInstance = scope; }}/>);
}
ReactDOM.render(<App />, document.getElementById('element'));
import { Calendar, CalendarComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

function App() {
    let calendarInstance: Calendar;
    React.useEffect(() => {
    const proxy = this;
    document.onkeyup = (e) => {
      if (e.altKey && e.keyCode === 84 /* t */) {
        // press altt to focus the control.
        proxy.calendarInstance.element.querySelector('table').focus();
      }
    };
    }, []);

    return (
        // specifies the tag for render the Calendar component
        <CalendarComponent id="calendar" ref={(scope) => { (calendarInstance as Calendar | null) = scope; }}  />
    );
}

ReactDOM.render(<App />, document.getElementById('element'));

Ensuring accessibility

The Calendar component’s accessibility levels are ensured through an accessibility-checker and axe-core software tools during automated testing.

The accessibility compliance of the Calendar component is shown in the following sample. Open the sample in a new window to evaluate the accessibility of the Calendar component with accessibility tools.

See also